(* Ein einfacher Editor mit ffnen und Speichern von Dateien.
   Dabei soll demonstriert werden, wie benutzerspezifische Angaben
   in einer Ini-Datei gespeichert werden.
   --------------------------------------------------------------
   Stichworte:  OpenDialog
                ClosDialog
                IniFiles
*)

unit Unieditor;  // DFM-Datei binr gespeichert.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, IniFiles;

type
  TFEditor1 = class(TForm)
    Panel1: TPanel;
    BOeffnen: TButton;
    BSichern: TButton;
    BLoeschen: TButton;
    BClose: TButton;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure BOeffnenClick(Sender: TObject);
    procedure BSichernClick(Sender: TObject);
    procedure BLoeschenClick(Sender: TObject);
    procedure BCloseClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FEditor1: TFEditor1;

implementation

{$R *.DFM}

function IniPfad:string;
begin
 result:=extractFilepath(paramstr(0))//der exe-pfad des Programms
         +'MyIni.ini';
end;

function HoleDateiPfad:string; //Dass man noch weiss, wo Datei gespeichert wurde.
  var MyIniFile:TIniFile;      //bentigt uses IniFiles.
  //Ini-Dateien sind besser als in Registry schreiben!
begin
  MyIniFile:=Tinifile.create(Inipfad);
  try
    result:=MyIniFile.ReadString('Section1','Schluessel1', 'File1');
  finally MyIniFile.Free End;
end;

procedure SchreibeDateiPfad(pfad:string); //Dass man noch weiss, wo Datei gespeichert wurde
  var MyIniFile:TIniFile;//bentigt uses IniFiles. So besser als in der Registry
begin
  MyIniFile:=Tinifile.create(Inipfad);
  try
    MyIniFile.WriteString('Section1','Schluessel1', pfad);
  finally MyIniFile.Free End;
end;



procedure TFEditor1.BOeffnenClick(Sender: TObject);
begin
 {Es funktioniert bereits mit den folgenden zwei Zeilen
  if OpenDialog1.Execute then
    memo1.Lines.LoadFromFile(Opendialog1.Filename);
 komfortabler ist:}
  with  opendialog1 do Begin //bewirkt, dass nicht stets "Opendialog1." geschriebeb werden muss
    title:='Hallo Festplatte! Jetzt bleibt mir nichts verborgen!';
    Initialdir:=extractFilepath(holedateipfad);
    filename:=extractFilename(holedateipfad);
    options:=[ofFileMustExist,ofAllowMultiselect,ofHideReadOnly,ofShareAware,
                ofEnableSizing,{ofShowHelp,}
                {ofOldStyleDialog,}ofNoTestFileCreate,ofNoValidate];
    Filter :='Pascal-Dateien (*.PAS)|*.PAS|Textdateien (*.txt)|*.TXT|'
              +'Alle Dateien (*.*)|*.*';
    DefaultExt:='';
    if Execute then Begin
      memo1.Lines.LoadFromFile(Opendialog1.Filename);
      SchreibeDateiPfad(Opendialog1.Filename);
    End else showmessage('Abbruch!');
 End;
end;

procedure TFEditor1.BSichernClick(Sender: TObject);

begin
 {Es funktioniert bereits mit den folgenden zwei Zeilen
    if SaveDialog1.Execute then
      memo1.Lines.SaveToFile(Savedialog1.Filename);
    komfortabler ist:}
   with SaveDialog1 do Begin //bewirkt, dass nicht stets "Savedialog1." geschriebeb werden muss
     Options:=[ofCreatePrompt,ofEnableSizing,ofHideReadOnly,ofShareAware,ofEnableSizing]; //Ohne Kstchen
     //Options:=[ofHideReadOnly,ofOverwritePrompt]; //Rckfrage entfllt
     Initialdir:=extractFilepath(HoleDateipfad);
     filename:=extractFilename(holedateipfad);
     Filter :='Pascal-Dateien (*.PAS)|*.PAS|Textdateien (*.txt)|*.TXT|'
               +'Alle Dateien (*.*)|*.*';
     DefaultExt:='';
     if execute then Begin
       memo1.Lines.SaveToFile(Savedialog1.Filename);
       schreibeDateiPfad(Savedialog1.Filename);
     End else showmessage('Nicht gespeichert');
   End;
end;

procedure TFEditor1.BLoeschenClick(Sender: TObject);
begin
  Memo1.lines.clear;
end;

procedure TFEditor1.BCloseClick(Sender: TObject);
begin
  close
end;

end.
